/**
Copyright: 2024 Contrast Security, Inc
  Contact: support@contrastsecurity.com
  License: Commercial

  NOTICE: This Software and the patented inventions embodied within may only be
  used as part of Contrast Security’s commercial offerings. Even though it is
  made available through public repositories, use of this Software is subject to
  the applicable End User Licensing Agreement found at
  https://www.contrastsecurity.com/enduser-terms-0317a or as otherwise agreed
  between Contrast Security and the End User. The Software may not be reverse
  engineered, modified, repackaged, sold, redistributed or otherwise used in a
  way not consistent with the End User License Agreement.
*/
'use strict';
const moduleHook = require('../../../hooks/require');
const AsyncStorage = require('../index');

/**
 * Redis doesn't properly support async hooks
 * In their code they bind a callback to a domain
 * but since this isn't an AsyncResource it loses
 * context when using async hooks
 *
 * https://github.com/NodeRedis/node-redis/blob/master/index.js#L807
 */
module.exports = function() {
  moduleHook.resolve({ name: 'redis', version: '<4.0.0' }, function(redis) {
    const origSend = redis.RedisClient.prototype.internal_send_command;
    redis.RedisClient.prototype.internal_send_command = function(command_obj) {
      if (command_obj && command_obj.callback) {
        command_obj.callback = AsyncStorage.bind(command_obj.callback);
      }

      return origSend.call(this, command_obj);
    };
  });
};
